/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.button;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.util.forge.ForgeStep;

import static net.dries007.tfc.client.gui.GuiAnvilTFC.ANVIL_BACKGROUND;

@SideOnly(Side.CLIENT)
public class GuiButtonAnvilStep extends GuiButtonTFC implements IButtonTooltip
{
    private final int textureU;
    private final int textureV;
    private final String tooltip;

    public GuiButtonAnvilStep(int id, int guiLeft, int guiTop, ForgeStep step)
    {
        super(id, guiLeft + step.getX(), guiTop + step.getY(), 16, 16, "");

        this.textureU = step.getU();
        this.textureV = step.getV();
        this.tooltip = I18n.func_135052_a("tfc.enum.forge_step." + step.name().toLowerCase());
    }

    @Override
    public void func_191745_a(@Nonnull Minecraft mc, int mouseX, int mouseY, float partialTicks)
    {
        if (this.field_146125_m)
        {
            GlStateManager.func_179131_c(1, 1, 1, 1);
            mc.func_110434_K().func_110577_a(ANVIL_BACKGROUND);
            field_146123_n = mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + this.field_146120_f && mouseY < this.field_146129_i + this.field_146121_g;
            //drawModalRectWithCustomSizedTexture(x, y, textureU, textureV, 32, 32, 256, 256);
            func_152125_a(field_146128_h, field_146129_i, textureU, textureV, 32, 32, 16, 16, 256, 256);
            func_146119_b(mc, mouseX, mouseY);
        }
    }

    @Override
    public String getTooltip()
    {
        return tooltip;
    }

    @Override
    public boolean hasTooltip()
    {
        return tooltip != null;
    }
}
