package net.dries007.tfc.client.model.animal;

import net.minecraft.client.model.ModelBase;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.util.math.MathHelper;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.entity.animal.EntityRabbitTFC;

@SideOnly(Side.CLIENT)
public class ModelRabbitTFC extends ModelBase
{
    private final ModelRenderer rabbitLeftFoot;
    private final ModelRenderer rabbitRightFoot;
    private final ModelRenderer rabbitLeftThigh;
    private final ModelRenderer rabbitRightThigh;
    private final ModelRenderer rabbitBody;
    private final ModelRenderer rabbitLeftArm;
    private final ModelRenderer rabbitRightArm;
    private final ModelRenderer rabbitHead;
    private final ModelRenderer rabbitRightEar;
    private final ModelRenderer rabbitLeftEar;
    private final ModelRenderer rabbitTail;
    private final ModelRenderer rabbitNose;
    private float jumpRotation;

    public ModelRabbitTFC()
    {
        this.func_78085_a("head.main", 0, 0);
        this.func_78085_a("head.nose", 0, 24);
        this.func_78085_a("head.ear1", 0, 10);
        this.func_78085_a("head.ear2", 6, 10);
        this.rabbitLeftFoot = new ModelRenderer(this, 26, 24);
        this.rabbitLeftFoot.func_78789_a(-1.0F, 5.5F, -3.7F, 2, 1, 7);
        this.rabbitLeftFoot.func_78793_a(3.0F, 17.5F, 3.7F);
        this.rabbitLeftFoot.field_78809_i = true;
        this.setRotationOffset(this.rabbitLeftFoot, 0.0F, 0.0F, 0.0F);
        this.rabbitRightFoot = new ModelRenderer(this, 8, 24);
        this.rabbitRightFoot.func_78789_a(-1.0F, 5.5F, -3.7F, 2, 1, 7);
        this.rabbitRightFoot.func_78793_a(-3.0F, 17.5F, 3.7F);
        this.rabbitRightFoot.field_78809_i = true;
        this.setRotationOffset(this.rabbitRightFoot, 0.0F, 0.0F, 0.0F);
        this.rabbitLeftThigh = new ModelRenderer(this, 30, 15);
        this.rabbitLeftThigh.func_78789_a(-1.0F, 0.0F, 0.0F, 2, 4, 5);
        this.rabbitLeftThigh.func_78793_a(3.0F, 17.5F, 3.7F);
        this.rabbitLeftThigh.field_78809_i = true;
        this.setRotationOffset(this.rabbitLeftThigh, -0.34906584F, 0.0F, 0.0F);
        this.rabbitRightThigh = new ModelRenderer(this, 16, 15);
        this.rabbitRightThigh.func_78789_a(-1.0F, 0.0F, 0.0F, 2, 4, 5);
        this.rabbitRightThigh.func_78793_a(-3.0F, 17.5F, 3.7F);
        this.rabbitRightThigh.field_78809_i = true;
        this.setRotationOffset(this.rabbitRightThigh, -0.34906584F, 0.0F, 0.0F);
        this.rabbitBody = new ModelRenderer(this, 0, 0);
        this.rabbitBody.func_78789_a(-3.0F, -2.0F, -10.0F, 6, 5, 10);
        this.rabbitBody.func_78793_a(0.0F, 19.0F, 8.0F);
        this.rabbitBody.field_78809_i = true;
        this.setRotationOffset(this.rabbitBody, -0.34906584F, 0.0F, 0.0F);
        this.rabbitLeftArm = new ModelRenderer(this, 8, 15);
        this.rabbitLeftArm.func_78789_a(-1.0F, 0.0F, -1.0F, 2, 7, 2);
        this.rabbitLeftArm.func_78793_a(3.0F, 17.0F, -1.0F);
        this.rabbitLeftArm.field_78809_i = true;
        this.setRotationOffset(this.rabbitLeftArm, -0.17453292F, 0.0F, 0.0F);
        this.rabbitRightArm = new ModelRenderer(this, 0, 15);
        this.rabbitRightArm.func_78789_a(-1.0F, 0.0F, -1.0F, 2, 7, 2);
        this.rabbitRightArm.func_78793_a(-3.0F, 17.0F, -1.0F);
        this.rabbitRightArm.field_78809_i = true;
        this.setRotationOffset(this.rabbitRightArm, -0.17453292F, 0.0F, 0.0F);
        this.rabbitHead = new ModelRenderer(this, 32, 0);
        this.rabbitHead.func_78789_a(-2.5F, -4.0F, -5.0F, 5, 4, 5);
        this.rabbitHead.func_78793_a(0.0F, 16.0F, -1.0F);
        this.rabbitHead.field_78809_i = true;
        this.setRotationOffset(this.rabbitHead, 0.0F, 0.0F, 0.0F);
        this.rabbitRightEar = new ModelRenderer(this, 52, 0);
        this.rabbitRightEar.func_78789_a(-2.5F, -9.0F, -1.0F, 2, 5, 1);
        this.rabbitRightEar.func_78793_a(0.0F, 16.0F, -1.0F);
        this.rabbitRightEar.field_78809_i = true;
        this.setRotationOffset(this.rabbitRightEar, 0.0F, -0.2617994F, 0.0F);
        this.rabbitLeftEar = new ModelRenderer(this, 58, 0);
        this.rabbitLeftEar.func_78789_a(0.5F, -9.0F, -1.0F, 2, 5, 1);
        this.rabbitLeftEar.func_78793_a(0.0F, 16.0F, -1.0F);
        this.rabbitLeftEar.field_78809_i = true;
        this.setRotationOffset(this.rabbitLeftEar, 0.0F, 0.2617994F, 0.0F);
        this.rabbitTail = new ModelRenderer(this, 52, 6);
        this.rabbitTail.func_78789_a(-1.5F, -1.5F, 0.0F, 3, 3, 2);
        this.rabbitTail.func_78793_a(0.0F, 20.0F, 7.0F);
        this.rabbitTail.field_78809_i = true;
        this.setRotationOffset(this.rabbitTail, -0.3490659F, 0.0F, 0.0F);
        this.rabbitNose = new ModelRenderer(this, 32, 9);
        this.rabbitNose.func_78789_a(-0.5F, -2.5F, -5.5F, 1, 1, 1);
        this.rabbitNose.func_78793_a(0.0F, 16.0F, -1.0F);
        this.rabbitNose.field_78809_i = true;
        this.setRotationOffset(this.rabbitNose, 0.0F, 0.0F, 0.0F);
    }

    public void func_78088_a(Entity entityIn, float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scale)
    {
        this.func_78087_a(limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale, entityIn);

        if (this.field_78091_s)
        {
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(0.56666666F, 0.56666666F, 0.56666666F);
            GlStateManager.func_179109_b(0.0F, 22.0F * scale, 2.0F * scale);
            this.rabbitHead.func_78785_a(scale);
            this.rabbitLeftEar.func_78785_a(scale);
            this.rabbitRightEar.func_78785_a(scale);
            this.rabbitNose.func_78785_a(scale);
            GlStateManager.func_179121_F();
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(0.4F, 0.4F, 0.4F);
            GlStateManager.func_179109_b(0.0F, 36.0F * scale, 0.0F);
            this.rabbitLeftFoot.func_78785_a(scale);
            this.rabbitRightFoot.func_78785_a(scale);
            this.rabbitLeftThigh.func_78785_a(scale);
            this.rabbitRightThigh.func_78785_a(scale);
            this.rabbitBody.func_78785_a(scale);
            this.rabbitLeftArm.func_78785_a(scale);
            this.rabbitRightArm.func_78785_a(scale);
            this.rabbitTail.func_78785_a(scale);
            GlStateManager.func_179121_F();
        }
        else
        {
            GlStateManager.func_179094_E();
            GlStateManager.func_179152_a(0.6F, 0.6F, 0.6F);
            GlStateManager.func_179109_b(0.0F, 16.0F * scale, 0.0F);
            this.rabbitLeftFoot.func_78785_a(scale);
            this.rabbitRightFoot.func_78785_a(scale);
            this.rabbitLeftThigh.func_78785_a(scale);
            this.rabbitRightThigh.func_78785_a(scale);
            this.rabbitBody.func_78785_a(scale);
            this.rabbitLeftArm.func_78785_a(scale);
            this.rabbitRightArm.func_78785_a(scale);
            this.rabbitHead.func_78785_a(scale);
            this.rabbitRightEar.func_78785_a(scale);
            this.rabbitLeftEar.func_78785_a(scale);
            this.rabbitTail.func_78785_a(scale);
            this.rabbitNose.func_78785_a(scale);
            GlStateManager.func_179121_F();
        }
    }

    public void func_78087_a(float limbSwing, float limbSwingAmount, float ageInTicks, float netHeadYaw, float headPitch, float scaleFactor, Entity entityIn)
    {
        float f = ageInTicks - (float) entityIn.field_70173_aa;
        EntityRabbitTFC EntityRabbitTFC = (EntityRabbitTFC) entityIn;
        this.rabbitNose.field_78795_f = headPitch * 0.017453292F;
        this.rabbitHead.field_78795_f = headPitch * 0.017453292F;
        this.rabbitRightEar.field_78795_f = headPitch * 0.017453292F;
        this.rabbitLeftEar.field_78795_f = headPitch * 0.017453292F;
        this.rabbitNose.field_78796_g = netHeadYaw * 0.017453292F;
        this.rabbitHead.field_78796_g = netHeadYaw * 0.017453292F;
        this.rabbitRightEar.field_78796_g = this.rabbitNose.field_78796_g - 0.2617994F;
        this.rabbitLeftEar.field_78796_g = this.rabbitNose.field_78796_g + 0.2617994F;
        this.jumpRotation = MathHelper.func_76126_a(EntityRabbitTFC.getJumpCompletion(f) * (float) Math.PI);
        this.rabbitLeftThigh.field_78795_f = (this.jumpRotation * 50.0F - 21.0F) * 0.017453292F;
        this.rabbitRightThigh.field_78795_f = (this.jumpRotation * 50.0F - 21.0F) * 0.017453292F;
        this.rabbitLeftFoot.field_78795_f = this.jumpRotation * 50.0F * 0.017453292F;
        this.rabbitRightFoot.field_78795_f = this.jumpRotation * 50.0F * 0.017453292F;
        this.rabbitLeftArm.field_78795_f = (this.jumpRotation * -40.0F - 11.0F) * 0.017453292F;
        this.rabbitRightArm.field_78795_f = (this.jumpRotation * -40.0F - 11.0F) * 0.017453292F;
    }

    public void func_78086_a(EntityLivingBase entitylivingbaseIn, float limbSwing, float limbSwingAmount, float partialTickTime)
    {
        super.func_78086_a(entitylivingbaseIn, limbSwing, limbSwingAmount, partialTickTime);
        this.jumpRotation = MathHelper.func_76126_a(((EntityRabbitTFC) entitylivingbaseIn).getJumpCompletion(partialTickTime) * (float) Math.PI);
    }

    private void setRotationOffset(ModelRenderer renderer, float x, float y, float z)
    {
        renderer.field_78795_f = x;
        renderer.field_78796_g = y;
        renderer.field_78808_h = z;
    }
}
