package net.dries007.tfc.client.render.animal;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.RenderLiving;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.client.model.animal.ModelWolfTFC;
import net.dries007.tfc.objects.entity.animal.EntityWolfTFC;

@SideOnly(Side.CLIENT)
public class RenderWolfTFC extends RenderLiving<EntityWolfTFC>
{
    private static final ResourceLocation WOLF_TEXTURES = new ResourceLocation("textures/entity/wolf/wolf.png");
    private static final ResourceLocation TAMED_WOLF_TEXTURES = new ResourceLocation("textures/entity/wolf/wolf_tame.png");
    private static final ResourceLocation ANRGY_WOLF_TEXTURES = new ResourceLocation("textures/entity/wolf/wolf_angry.png");

    public RenderWolfTFC(RenderManager renderManager)
    {
        super(renderManager, new ModelWolfTFC(), 0.5F);
        this.func_177094_a(new LayerWolfCollarTFC(this));
    }

    /**
     * Defines what float the third param in setRotationAngles of ModelBase is
     */
    protected float func_77044_a(EntityWolfTFC livingBase, float partialTicks)
    {
        return livingBase.getTailRotation();
    }

    /**
     * Renders the desired {@code T} type Entity.
     */
    public void func_76986_a(EntityWolfTFC entity, double x, double y, double z, float entityYaw, float partialTicks)
    {
        if (entity.isWolfWet())
        {
            float f = entity.func_70013_c() * entity.getShadingWhileWet(partialTicks);
            GlStateManager.func_179124_c(f, f, f);
        }

        super.func_76986_a(entity, x, y, z, entityYaw, partialTicks);
    }

    /**
     * Returns the location of an entity's texture. Doesn't seem to be called unless you call Render.bindEntityTexture.
     */
    protected ResourceLocation func_110775_a(EntityWolfTFC entity)
    {
        if (entity.isTamed())
        {
            return TAMED_WOLF_TEXTURES;
        }
        else
        {
            return entity.isAngry() ? ANRGY_WOLF_TEXTURES : WOLF_TEXTURES;
        }
    }
}
