/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render.projectile;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.RenderItem;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.entity.projectile.EntityThrownWeapon;

@SideOnly(Side.CLIENT)
public class RenderThrownWeapon<T extends EntityThrownWeapon> extends Render<T>
{
    private final RenderItem itemRenderer;

    public RenderThrownWeapon(RenderManager renderManagerIn)
    {
        super(renderManagerIn);
        this.itemRenderer = Minecraft.func_71410_x().func_175599_af();
    }

    public void func_76986_a(@Nonnull T entity, double x, double y, double z, float entityYaw, float partialTicks)
    {
        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b((float) x, (float) y, (float) z);
        GlStateManager.func_179091_B();


        doRenderTransformations(entity, partialTicks);

        func_110776_a(func_110775_a(entity));

        if (this.field_188301_f)
        {

            GlStateManager.func_179142_g();
            GlStateManager.func_187431_e(func_188298_c(entity));
        }


        ItemStack weapon = entity.getWeapon();
        if (!weapon.func_190926_b())
        {
            this.itemRenderer.func_181564_a(weapon, ItemCameraTransforms.TransformType.GROUND);
        }

        if (this.field_188301_f)
        {

            GlStateManager.func_187417_n();
            GlStateManager.func_179119_h();
        }

        GlStateManager.func_179101_C();
        GlStateManager.func_179121_F();
        super.func_76986_a(entity, x, y, z, entityYaw, partialTicks);
    }

    @Override
    @Nonnull
    protected ResourceLocation func_110775_a(@Nonnull T entity) { return TextureMap.field_110575_b; }

    protected void doRenderTransformations(T entity, float partialTicks)
    {
        GlStateManager.func_179114_b(entity.field_70126_B + (entity.field_70177_z - entity.field_70126_B) * partialTicks - 90.0F, 0.0F, 1.0F, 0.0F);
        GlStateManager.func_179114_b(entity.field_70127_C + (entity.field_70125_A - entity.field_70127_C) * partialTicks - 135.0F, 0.0F, 0.0F, 1.0F);

        GlStateManager.func_179137_b(-0.15D, -0.15D, 0.0D);
    }
}
