/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.blocks.wood;

import java.util.HashMap;
import java.util.Map;

import net.minecraft.block.BlockFence;
import net.minecraft.block.material.Material;
import net.minecraft.init.Blocks;

import net.dries007.tfc.api.types.Tree;
import net.dries007.tfc.util.OreDictionaryHelper;

public class BlockFenceTFC extends BlockFence
{
    private static final Map<Tree, BlockFenceTFC> MAP = new HashMap<>();

    public static BlockFenceTFC get(Tree wood)
    {
        return MAP.get(wood);
    }

    public final Tree wood;

    public BlockFenceTFC(Tree wood)
    {
        super(Material.field_151575_d, Material.field_151575_d.func_151565_r());
        if (MAP.put(wood, this) != null) throw new IllegalStateException("There can only be one.");
        this.wood = wood;
        setHarvestLevel("axe", 0);
        OreDictionaryHelper.register(this, "fence");
        OreDictionaryHelper.register(this, "fence", wood.getRegistryName().func_110623_a());
        Blocks.field_150480_ab.func_180686_a(this, 5, 20);
    }
}
