/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.container;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.entity.player.InventoryPlayer;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import mcp.MethodsReturnNonnullByDefault;
import net.dries007.tfc.objects.inventory.slot.SlotCallback;
import net.dries007.tfc.objects.te.TENestBox;

@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public class ContainerNestBox extends ContainerTE<TENestBox>
{
    private static final int[] SLOT_SHIFT_ORDER = new int[] {0, 1, 2, 3};

    public ContainerNestBox(InventoryPlayer playerInv, TENestBox te)
    {
        super(playerInv, te);
    }

    @Override
    protected void addContainerSlots()
    {
        IItemHandler inventory = tile.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);
        if (inventory != null)
        {
            func_75146_a(new SlotCallback(inventory, 0, 71, 23, tile));
            func_75146_a(new SlotCallback(inventory, 1, 89, 23, tile));
            func_75146_a(new SlotCallback(inventory, 2, 71, 41, tile));
            func_75146_a(new SlotCallback(inventory, 3, 89, 41, tile));
        }
    }

    @Override
    protected int[] getSlotShiftOrder(int containerSlots)
    {
        return SLOT_SHIFT_ORDER;
    }
}
