/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.container;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

/**
 * A very simple container implementation.
 * Used for gui's that have no internal inventory, or no TE they need to access
 * Prefer using {@link ContainerTE} instead for tile entities or {@link ContainerItemStack} for items
 */
@ParametersAreNonnullByDefault
public class ContainerSimple extends Container
{
    public ContainerSimple() { }

    public ContainerSimple(InventoryPlayer playerInv)
    {
        addPlayerInventorySlots(playerInv);
    }

    @Override
    @Nonnull
    public ItemStack func_82846_b(EntityPlayer player, int index)
    {
        ItemStack stackCopy = ItemStack.field_190927_a;
        Slot slot = this.field_75151_b.get(index);

        if (slot != null && slot.func_75216_d())
        {
            ItemStack stack = slot.func_75211_c();
            stackCopy = stack.func_77946_l();

            if (index < 27)
            {
                if (!this.func_75135_a(stack, 27, 36, false))
                {
                    return ItemStack.field_190927_a;
                }
            }
            else
            {
                if (!this.func_75135_a(stack, 0, 27, false))
                {
                    return ItemStack.field_190927_a;
                }
            }

            if (stack.func_190926_b())
            {
                slot.func_75215_d(ItemStack.field_190927_a);
            }
            else
            {
                slot.func_75218_e();
            }

            if (stack.func_190916_E() == stackCopy.func_190916_E())
            {
                return ItemStack.field_190927_a;
            }

            ItemStack stackTake = slot.func_190901_a(player, stack);
            if (index == 0)
            {
                player.func_71019_a(stackTake, false);
            }
        }

        return stackCopy;
    }

    @Override
    public boolean func_75145_c(EntityPlayer playerIn)
    {
        return true;
    }

    protected void addPlayerInventorySlots(InventoryPlayer playerInv)
    {
        addPlayerInventorySlots(playerInv, 0);
    }

    protected void addPlayerInventorySlots(InventoryPlayer playerInv, int yOffset)
    {
        // Add Player Inventory Slots
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 9; j++)
            {
                func_75146_a(new Slot(playerInv, j + i * 9 + 9, 8 + j * 18, 84 + i * 18 + yOffset));
            }
        }

        for (int k = 0; k < 9; k++)
        {
            func_75146_a(new Slot(playerInv, k, 8 + k * 18, 142 + yOffset));
        }
    }
}
