package net.dries007.tfc.objects.entity.ai;

import net.dries007.tfc.objects.entity.animal.EntityWolfTFC;
import net.minecraft.entity.ai.EntityAIBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumHand;
import net.minecraft.world.World;

public class EntityAIBegTFC extends EntityAIBase
{
    private final EntityWolfTFC wolf;
    private EntityPlayer player;
    private final World world;
    private final float minPlayerDistance;
    private int timeoutCounter;

    public EntityAIBegTFC(EntityWolfTFC wolf, float minDistance)
    {
        this.wolf = wolf;
        this.world = wolf.field_70170_p;
        this.minPlayerDistance = minDistance;
        this.func_75248_a(2);
    }

    public boolean func_75250_a()
    {
        this.player = this.world.func_72890_a(this.wolf, (double)this.minPlayerDistance);
        return this.player == null ? false : this.hasTemptationItemInHand(this.player);
    }

    public boolean func_75253_b()
    {
        if (!this.player.func_70089_S())
        {
            return false;
        }
        else if (this.wolf.func_70068_e(this.player) > (double)(this.minPlayerDistance * this.minPlayerDistance))
        {
            return false;
        }
        else
        {
            return this.timeoutCounter > 0 && this.hasTemptationItemInHand(this.player);
        }
    }

    public void func_75249_e()
    {
        this.wolf.setBegging(true);
        this.timeoutCounter = 40 + this.wolf.func_70681_au().nextInt(40);
    }

    public void func_75251_c()
    {
        this.wolf.setBegging(false);
        this.player = null;
    }

    public void func_75246_d()
    {
        this.wolf.func_70671_ap().func_75650_a(this.player.field_70165_t, this.player.field_70163_u + (double)this.player.func_70047_e(), this.player.field_70161_v, 10.0F, (float)this.wolf.func_70646_bf());
        --this.timeoutCounter;
    }

    private boolean hasTemptationItemInHand(EntityPlayer player)
    {
        for (EnumHand enumhand : EnumHand.values())
        {
            ItemStack itemstack = player.func_184586_b(enumhand);

            if (this.wolf.isTamed() && itemstack.func_77973_b() == Items.field_151103_aS)
            {
                return true;
            }

            if (this.wolf.func_70877_b(itemstack))
            {
                return true;
            }
        }

        return false;
    }
}
