/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.inventory.ingredient;

import javax.annotation.Nonnull;

import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;

public class IngredientItemStack implements IIngredient<ItemStack>
{
    private final ItemStack inputStack;

    IngredientItemStack(@Nonnull ItemStack inputStack)
    {
        this.inputStack = inputStack;
    }

    @Override
    public boolean test(ItemStack stack)
    {
        return testIgnoreCount(stack) && stack.func_190916_E() >= inputStack.func_190916_E();
    }

    @Override
    public boolean testIgnoreCount(ItemStack stack)
    {
        if (stack != null && !stack.func_190926_b())
        {
            if (inputStack.func_77973_b() == stack.func_77973_b())
            {
                return inputStack.func_77960_j() == OreDictionary.WILDCARD_VALUE || inputStack.func_77960_j() == stack.func_77960_j();
            }
        }
        return false;
    }

    @Override
    @Nonnull
    public ItemStack consume(ItemStack input)
    {
        input.func_190918_g(inputStack.func_190916_E());
        return input;
    }

    @Override
    public int getAmount()
    {
        return inputStack.func_190916_E();
    }
}
