/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.Constants;
import net.dries007.tfc.util.Helpers;

@ParametersAreNonnullByDefault
public class TEPlacedItemFlat extends TEBase
{
    private byte rotation;
    private ItemStack inventory;

    public TEPlacedItemFlat()
    {
        rotation = (byte) Constants.RNG.nextInt(4);
        inventory = ItemStack.field_190927_a;
    }

    public void onBreakBlock(BlockPos pos)
    {
        if (!field_145850_b.field_72995_K && !inventory.func_190926_b())
        {
            Helpers.spawnItemStack(field_145850_b, pos, getStack());
        }
    }

    @Override
    public void func_145839_a(NBTTagCompound nbt)
    {
        rotation = nbt.func_74764_b("rotation") ? nbt.func_74771_c("rotation") : 0;
        inventory = new ItemStack(nbt.func_74775_l("stack"));
        super.func_145839_a(nbt);
    }

    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound nbt)
    {
        nbt.func_74774_a("rotation", rotation);
        nbt.func_74782_a("stack", inventory.serializeNBT());
        return super.func_189515_b(nbt);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public double func_145833_n()
    {
        return 1024.0D;
    }

    @Override
    @Nonnull
    @SideOnly(Side.CLIENT)
    public AxisAlignedBB getRenderBoundingBox()
    {
        return new AxisAlignedBB(func_174877_v(), func_174877_v().func_177963_a(1D, 1D, 1D));
    }

    public byte getRotation()
    {
        return rotation;
    }

    public ItemStack getStack()
    {
        return inventory;
    }

    public void setStack(ItemStack stack)
    {
        this.inventory = stack;
        func_70296_d();
    }
}
